#!/bin/sh

export PATH=$PATH:/bin/:/sbin/:/usr/bin/:/usr/local/bin/:/usr/sbin/:/usr/local/sbin/
PROPERTY=$1

case $PROPERTY in

        'manufacturer')
                DMIDECODE=`which dmidecode 2> /dev/null`
                if [ -f $DMIDECODE ]
                then
                        #echo "dmidecode exists"
                        mfg=`dmidecode -t system | grep -i "Manufacturer" | cut -d ":" -f2`
                else
                        #echo "dmidecode does not exist"
                        LSHAL=`which lshal 2> /dev/null`
                        if [ -f $LSHAL ]
                        then
                                mfg=`lshal  | grep -i system.manufacturer | cut -d "'" -f2`
                                if [[ -z "$mfg" ]]
                                then
                                        mfg=`lshal  | grep -i system.hardware.vendor | cut -d "'" -f2`
                                fi
                        fi
                fi
                if [[ -z "$mfg" ]]
                then
                        mfg="Unknown"
                fi
                echo $mfg;
        ;;

        'model')
                DMIDECODE=`which dmidecode 2> /dev/null`
                if [ -f $DMIDECODE ]
                then
                        #echo "dmidecode exists"
                        model=`dmidecode -t system | grep -i "Product Name" | cut -d ":" -f2`
                else
                        #echo "dmidecode does not exist"
                        LSHAL=`which lshal 2> /dev/null`
                        if [ -f $LSHAL ]
                        then
                                model=`lshal  | grep -i smbios.system.product | cut -d "'" -f2`
                                if [[ -z "$model" ]]
                                then
                                        model=`lshal  | grep -i system.hardware.product | cut -d "'" -f2`
                                fi
                        fi
                fi
                if [[ -z "$model" ]]
                then
                        model="Unknown"
                fi
                echo $model;
        ;;


        'serialno')
                DMIDECODE=`which dmidecode 2> /dev/null`
                if [ -f $DMIDECODE ]
                then
                        #echo "dmidecode exists"
                        serialno=`dmidecode -t system | grep -i "Serial Number"| cut -d ":" -f2`
                else
                        #echo "dmidecode does not exist"
                        LSHAL=`which lshal 2> /dev/null`
                        if [ -f $LSHAL ]
                        then
                                serialno=`lshal  | grep -i smbios.system.product | cut -d "'" -f2`
                                if [[ -z "$serialno" ]]
                                then
                                        serialno=`lshal  | grep -i system.hardware.serial | cut -d "'" -f2`
                                fi
                        fi
                fi
                if [[ -z "$serialno" ]]
                then
                        serialno="Unknown"
                fi
                echo $serialno
        ;;

        'macaddress')
                ifconfig | grep -io -m1 '[0-9A-F]\{2\}\(:[0-9A-F]\{2\}\)\{5\}'
        ;;

        'os_distribution')
                uname -o
        ;;

        'version')
                uname -r
        ;;

        'architecture')
                uname -m
        ;;

        'total_ram')
                kb=`cat /proc/meminfo | grep -i "MemTotal" | grep -io '[0-9]\+'`
                echo `expr $kb \\* 1024`
        ;;

        *) echo "Unknown";;

esac
